/* This file has been generated by the Perl script `afblue.pl', */
/* using data from file `afblue.dat'.                           */

/***************************************************************************/
/*                                                                         */
/*  afblue.h                                                               */
/*                                                                         */
/*    Auto-fitter data for blue strings (specification).                   */
/*                                                                         */
/*  Copyright 2013-2017 by                                                 */
/*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
/*                                                                         */
/*  This file is part of the FreeType project, and may only be used,       */
/*  modified, and distributed under the terms of the FreeType project      */
/*  license, LICENSE.TXT.  By continuing to use, modify, or distribute     */
/*  this file you indicate that you have read the license and              */
/*  understand and accept it fully.                                        */
/*                                                                         */
/***************************************************************************/


#ifndef AFBLUE_H_
#define AFBLUE_H_


FT_BEGIN_HEADER


  /* an auxiliary macro to decode a UTF-8 character -- since we only use */
  /* hard-coded, self-converted data, no error checking is performed     */
#define GET_UTF8_CHAR( ch, p )                      \
          do                                        \
          {                                         \
            ch = (unsigned char)*p++;               \
            if ( ch >= 0x80 )                       \
            {                                       \
              FT_UInt  len_;                        \
                                                    \
                                                    \
              if ( ch < 0xE0 )                      \
              {                                     \
                len_ = 1;                           \
                ch  &= 0x1F;                        \
              }                                     \
              else if ( ch < 0xF0 )                 \
              {                                     \
                len_ = 2;                           \
                ch  &= 0x0F;                        \
              }                                     \
              else                                  \
              {                                     \
                len_ = 3;                           \
                ch  &= 0x07;                        \
              }                                     \
                                                    \
              for ( ; len_ > 0; len_-- )            \
                ch = ( ch << 6 ) | ( *p++ & 0x3F ); \
            }                                       \
          } while ( 0 )


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                    B L U E   S T R I N G S                    *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* At the bottommost level, we define strings for finding blue zones. */


#define AF_BLUE_STRING_MAX_LEN  51

  /* The AF_Blue_String enumeration values are offsets into the */
  /* `af_blue_strings' array.                                   */

  typedef enum  AF_Blue_String_
  {
    AF_BLUE_STRING_ADLAM_CAPITAL_TOP = 0,
    AF_BLUE_STRING_ADLAM_CAPITAL_BOTTOM = 30,
    AF_BLUE_STRING_ADLAM_SMALL_TOP = 40,
    AF_BLUE_STRING_ADLAM_SMALL_BOTTOM = 65,
    AF_BLUE_STRING_ARABIC_TOP = 105,
    AF_BLUE_STRING_ARABIC_BOTTOM = 123,
    AF_BLUE_STRING_ARABIC_JOIN = 138,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_TOP = 141,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_BOTTOM = 165,
    AF_BLUE_STRING_ARMENIAN_SMALL_ASCENDER = 189,
    AF_BLUE_STRING_ARMENIAN_SMALL_TOP = 210,
    AF_BLUE_STRING_ARMENIAN_SMALL_BOTTOM = 234,
    AF_BLUE_STRING_ARMENIAN_SMALL_DESCENDER = 258,
    AF_BLUE_STRING_AVESTAN_TOP = 282,
    AF_BLUE_STRING_AVESTAN_BOTTOM = 302,
    AF_BLUE_STRING_BENGALI_BASE = 312,
    AF_BLUE_STRING_BENGALI_TOP = 344,
    AF_BLUE_STRING_BENGALI_HEAD = 372,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_TOP = 404,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_BOTTOM = 436,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_TOP = 468,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SMALL_BOTTOM = 500,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_TOP = 532,
    AF_BLUE_STRING_CANADIAN_SYLLABICS_SUPS_BOTTOM = 560,
    AF_BLUE_STRING_CHEROKEE_CAPITAL = 592,
    AF_BLUE_STRING_CHEROKEE_SMALL_ASCENDER = 624,
    AF_BLUE_STRING_CHEROKEE_SMALL = 656,
    AF_BLUE_STRING_CHEROKEE_SMALL_DESCENDER = 688,
    AF_BLUE_STRING_CYPRIOT_TOP = 704,
    AF_BLUE_STRING_CYPRIOT_BOTTOM = 744,
    AF_BLUE_STRING_CYPRIOT_SMALL = 779,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_TOP = 794,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_BOTTOM = 818,
    AF_BLUE_STRING_CYRILLIC_SMALL = 842,
    AF_BLUE_STRING_CYRILLIC_SMALL_DESCENDER = 866,
    AF_BLUE_STRING_DESERET_CAPITAL_TOP = 875,
    AF_BLUE_STRING_DESERET_CAPITAL_BOTTOM = 900,
    AF_BLUE_STRING_DESERET_SMALL_TOP = 925,
    AF_BLUE_STRING_DESERET_SMALL_BOTTOM = 950,
    AF_BLUE_STRING_DEVANAGARI_BASE = 975,
    AF_BLUE_STRING_DEVANAGARI_TOP = 1007,
    AF_BLUE_STRING_DEVANAGARI_HEAD = 1039,
    AF_BLUE_STRING_DEVANAGARI_BOTTOM = 1071,
    AF_BLUE_STRING_ETHIOPIC_TOP = 1079,
    AF_BLUE_STRING_ETHIOPIC_BOTTOM = 1111,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_TOP = 1143,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_BOTTOM = 1175,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_ASCENDER = 1207,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_DESCENDER = 1239,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_TOP = 1271,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_BOTTOM = 1303,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_TOP = 1335,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_BOTTOM = 1367,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_ASCENDER = 1399,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_DESCENDER = 1431,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_TOP = 1463,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_BOTTOM = 1495,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_TOP = 1527,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_BOTTOM = 1559,
    AF_BLUE_STRING_GOTHIC_TOP = 1591,
    AF_BLUE_STRING_GOTHIC_BOTTOM = 1631,
    AF_BLUE_STRING_GREEK_CAPITAL_TOP = 1651,
    AF_BLUE_STRING_GREEK_CAPITAL_BOTTOM = 1672,
    AF_BLUE_STRING_GREEK_SMALL_BETA_TOP = 1690,
    AF_BLUE_STRING_GREEK_SMALL = 1708,
    AF_BLUE_STRING_GREEK_SMALL_DESCENDER = 1732,
    AF_BLUE_STRING_GUJARATI_TOP = 1756,
    AF_BLUE_STRING_GUJARATI_BOTTOM = 1788,
    AF_BLUE_STRING_GUJARATI_ASCENDER = 1820,
    AF_BLUE_STRING_GUJARATI_DESCENDER = 1870,
    AF_BLUE_STRING_GUJARATI_DIGIT_TOP = 1903,
    AF_BLUE_STRING_GURMUKHI_BASE = 1923,
    AF_BLUE_STRING_GURMUKHI_HEAD = 1955,
    AF_BLUE_STRING_GURMUKHI_TOP = 1987,
    AF_BLUE_STRING_GURMUKHI_BOTTOM = 2019,
    AF_BLUE_STRING_GURMUKHI_DIGIT_TOP = 2051,
    AF_BLUE_STRING_HEBREW_TOP = 2071,
    AF_BLUE_STRING_HEBREW_BOTTOM = 2095,
    AF_BLUE_STRING_HEBREW_DESCENDER = 2113,
    AF_BLUE_STRING_KANNADA_TOP = 2128,
    AF_BLUE_STRING_KANNADA_BOTTOM = 2172,
    AF_BLUE_STRING_KHMER_TOP = 2204,
    AF_BLUE_STRING_KHMER_SUBSCRIPT_TOP = 2228,
    AF_BLUE_STRING_KHMER_BOTTOM = 2268,
    AF_BLUE_STRING_KHMER_DESCENDER = 2300,
    AF_BLUE_STRING_KHMER_LARGE_DESCENDER = 2334,
    AF_BLUE_STRING_KHMER_SYMBOLS_WAXING_TOP = 2421,
    AF_BLUE_STRING_KHMER_SYMBOLS_WANING_BOTTOM = 2429,
    AF_BLUE_STRING_LAO_TOP = 2437,
    AF_BLUE_STRING_LAO_BOTTOM = 2469,
    AF_BLUE_STRING_LAO_ASCENDER = 2501,
    AF_BLUE_STRING_LAO_LARGE_ASCENDER = 2517,
    AF_BLUE_STRING_LAO_DESCENDER = 2529,
    AF_BLUE_STRING_LATIN_CAPITAL_TOP = 2553,
    AF_BLUE_STRING_LATIN_CAPITAL_BOTTOM = 2569,
    AF_BLUE_STRING_LATIN_SMALL_F_TOP = 2585,
    AF_BLUE_STRING_LATIN_SMALL_TOP = 2599,
    AF_BLUE_STRING_LATIN_SMALL_BOTTOM = 2615,
    AF_BLUE_STRING_LATIN_SMALL_DESCENDER = 2631,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_TOP = 2641,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_BOTTOM = 2661,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_F_TOP = 2681,
    AF_BLUE_STRING_LATIN_SUBS_SMALL = 2701,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_DESCENDER = 2737,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_TOP = 2757,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_BOTTOM = 2788,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_F_TOP = 2817,
    AF_BLUE_STRING_LATIN_SUPS_SMALL = 2843,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_DESCENDER = 2868,
    AF_BLUE_STRING_LISU_TOP = 2879,
    AF_BLUE_STRING_LISU_BOTTOM = 2911,
    AF_BLUE_STRING_MALAYALAM_TOP = 2943,
    AF_BLUE_STRING_MALAYALAM_BOTTOM = 2987,
    AF_BLUE_STRING_MYANMAR_TOP = 3019,
    AF_BLUE_STRING_MYANMAR_BOTTOM = 3051,
    AF_BLUE_STRING_MYANMAR_ASCENDER = 3083,
    AF_BLUE_STRING_MYANMAR_DESCENDER = 3111,
    AF_BLUE_STRING_NKO_TOP = 3143,
    AF_BLUE_STRING_NKO_BOTTOM = 3167,
    AF_BLUE_STRING_NKO_SMALL_TOP = 3182,
    AF_BLUE_STRING_NKO_SMALL_BOTTOM = 3191,
    AF_BLUE_STRING_OL_CHIKI = 3203,
    AF_BLUE_STRING_OLD_TURKIC_TOP = 3227,
    AF_BLUE_STRING_OLD_TURKIC_BOTTOM = 3242,
    AF_BLUE_STRING_OSAGE_CAPITAL_TOP = 3262,
    AF_BLUE_STRING_OSAGE_CAPITAL_BOTTOM = 3302,
    AF_BLUE_STRING_OSAGE_CAPITAL_DESCENDER = 3332,
    AF_BLUE_STRING_OSAGE_SMALL_TOP = 3347,
    AF_BLUE_STRING_OSAGE_SMALL_BOTTOM = 3387,
    AF_BLUE_STRING_OSAGE_SMALL_ASCENDER = 3427,
    AF_BLUE_STRING_OSAGE_SMALL_DESCENDER = 3452,
    AF_BLUE_STRING_SINHALA_TOP = 3467,
    AF_BLUE_STRING_SINHALA_BOTTOM = 3499,
    AF_BLUE_STRING_SINHALA_DESCENDER = 3531,
    AF_BLUE_STRING_SUNDANESE_TOP = 3575,
    AF_BLUE_STRING_SUNDANESE_BOTTOM = 3599,
    AF_BLUE_STRING_SUNDANESE_DESCENDER = 3631,
    AF_BLUE_STRING_TAI_VIET_TOP = 3639,
    AF_BLUE_STRING_TAI_VIET_BOTTOM = 3659,
    AF_BLUE_STRING_TAMIL_TOP = 3671,
    AF_BLUE_STRING_TAMIL_BOTTOM = 3703,
    AF_BLUE_STRING_TELUGU_TOP = 3735,
    AF_BLUE_STRING_TELUGU_BOTTOM = 3763,
    AF_BLUE_STRING_THAI_TOP = 3791,
    AF_BLUE_STRING_THAI_BOTTOM = 3815,
    AF_BLUE_STRING_THAI_ASCENDER = 3843,
    AF_BLUE_STRING_THAI_LARGE_ASCENDER = 3855,
    AF_BLUE_STRING_THAI_DESCENDER = 3867,
    AF_BLUE_STRING_THAI_LARGE_DESCENDER = 3883,
    AF_BLUE_STRING_THAI_DIGIT_TOP = 3891,
    AF_BLUE_STRING_TIFINAGH = 3903,
    af_blue_1_1 = 3934,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRING_CJK_TOP = af_blue_1_1 + 1,
    AF_BLUE_STRING_CJK_BOTTOM = af_blue_1_1 + 203,
    af_blue_1_1_1 = af_blue_1_1 + 404,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    AF_BLUE_STRING_CJK_LEFT = af_blue_1_1_1 + 1,
    AF_BLUE_STRING_CJK_RIGHT = af_blue_1_1_1 + 204,
    af_blue_1_1_2 = af_blue_1_1_1 + 405,
#else
    af_blue_1_1_2 = af_blue_1_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_1_2 = af_blue_1_1_2 + 0,
#else
    af_blue_1_2 = af_blue_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRING_MAX   /* do not remove */

  } AF_Blue_String;


  FT_LOCAL_ARRAY( char )
  af_blue_strings[];


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                 B L U E   S T R I N G S E T S                 *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* The next level is to group blue strings into style-specific sets. */


  /* Properties are specific to a writing system.  We assume that a given  */
  /* blue string can't be used in more than a single writing system, which */
  /* is a safe bet.                                                        */
#define AF_BLUE_PROPERTY_LATIN_TOP       ( 1U << 0 )  /* must have value 1 */
#define AF_BLUE_PROPERTY_LATIN_SUB_TOP   ( 1U << 1 )
#define AF_BLUE_PROPERTY_LATIN_NEUTRAL   ( 1U << 2 )
#define AF_BLUE_PROPERTY_LATIN_X_HEIGHT  ( 1U << 3 )
#define AF_BLUE_PROPERTY_LATIN_LONG      ( 1U << 4 )

#define AF_BLUE_PROPERTY_CJK_TOP    ( 1U << 0 )       /* must have value 1 */
#define AF_BLUE_PROPERTY_CJK_HORIZ  ( 1U << 1 )       /* must have value 2 */
#define AF_BLUE_PROPERTY_CJK_RIGHT  AF_BLUE_PROPERTY_CJK_TOP


#define AF_BLUE_STRINGSET_MAX_LEN  8

  /* The AF_Blue_Stringset enumeration values are offsets into the */
  /* `af_blue_stringsets' array.                                   */

  typedef enum  AF_Blue_Stringset_
  {
    AF_BLUE_STRINGSET_ADLM = 0,
    AF_BLUE_STRINGSET_ARAB = 5,
    AF_BLUE_STRINGSET_ARMN = 9,
    AF_BLUE_STRINGSET_AVST = 16,
    AF_BLUE_STRINGSET_BENG = 19,
    AF_BLUE_STRINGSET_CANADIAN_SYLLABICS = 24,
    AF_BLUE_STRINGSET_CHER = 31,
    AF_BLUE_STRINGSET_CPRT = 38,
    AF_BLUE_STRINGSET_CYRL = 43,
    AF_BLUE_STRINGSET_DEVA = 49,
    AF_BLUE_STRINGSET_DSRT = 55,
    AF_BLUE_STRINGSET_ETHI = 60,
    AF_BLUE_STRINGSET_GEOR = 63,
    AF_BLUE_STRINGSET_GEOK = 68,
    AF_BLUE_STRINGSET_GLAG = 75,
    AF_BLUE_STRINGSET_GOTH = 80,
    AF_BLUE_STRINGSET_GREK = 83,
    AF_BLUE_STRINGSET_GUJR = 90,
    AF_BLUE_STRINGSET_GURU = 96,
    AF_BLUE_STRINGSET_HEBR = 102,
    AF_BLUE_STRINGSET_KNDA = 106,
    AF_BLUE_STRINGSET_KHMR = 109,
    AF_BLUE_STRINGSET_KHMS = 115,
    AF_BLUE_STRINGSET_LAO = 118,
    AF_BLUE_STRINGSET_LATN = 124,
    AF_BLUE_STRINGSET_LATB = 131,
    AF_BLUE_STRINGSET_LATP = 138,
    AF_BLUE_STRINGSET_LISU = 145,
    AF_BLUE_STRINGSET_MLYM = 148,
    AF_BLUE_STRINGSET_MYMR = 151,
    AF_BLUE_STRINGSET_NKOO = 156,
    AF_BLUE_STRINGSET_NONE = 161,
    AF_BLUE_STRINGSET_OLCK = 162,
    AF_BLUE_STRINGSET_ORKH = 165,
    AF_BLUE_STRINGSET_OSGE = 168,
    AF_BLUE_STRINGSET_SINH = 176,
    AF_BLUE_STRINGSET_SUND = 180,
    AF_BLUE_STRINGSET_TAML = 184,
    AF_BLUE_STRINGSET_TAVT = 187,
    AF_BLUE_STRINGSET_TELU = 190,
    AF_BLUE_STRINGSET_THAI = 193,
    AF_BLUE_STRINGSET_TFNG = 201,
    af_blue_2_1 = 204,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRINGSET_HANI = af_blue_2_1 + 0,
    af_blue_2_1_1 = af_blue_2_1 + 2,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    af_blue_2_1_2 = af_blue_2_1_1 + 2,
#else
    af_blue_2_1_2 = af_blue_2_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_2_2 = af_blue_2_1_2 + 1,
#else
    af_blue_2_2 = af_blue_2_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRINGSET_MAX   /* do not remove */

  } AF_Blue_Stringset;


  typedef struct  AF_Blue_StringRec_
  {
    AF_Blue_String  string;
    FT_UShort       properties;

  } AF_Blue_StringRec;


  FT_LOCAL_ARRAY( AF_Blue_StringRec )
  af_blue_stringsets[];

/* */

FT_END_HEADER


#endif /* AFBLUE_H_ */


/* END */
